.\" Copyright (c) 1980, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)re_comp.3	8.1 (Berkeley) 6/4/93
.\"	$NetBSD: re_comp.3,v 1.10 2003/04/16 13:34:59 wiz Exp $
.\"
.Dd June 4, 1993
.Dt RE_COMP 3
.Os
.Sh NAME
.Nm re_comp ,
.Nm re_exec
.Nd regular expression handler
.Sh LIBRARY
.Lb libcompat
.Sh SYNOPSIS
.In re_comp.h
.Ft char *
.Fn re_comp "const char *s"
.Ft int
.Fn re_exec "const char *s"
.Sh DESCRIPTION
.Bf -symbolic
This interface is made obsolete by
.Xr regex 3 .
It is available from the compatibility library, libcompat.
.Ef
.Pp
The
.Fn re_comp
function
compiles a string into an internal form suitable for pattern matching.
The
.Fn re_exec
function
checks the argument string against the last string passed to
.Fn re_comp .
.Pp
The
.Fn re_comp
function
returns 0 if the string
.Fa s
was compiled successfully; otherwise a string containing an
error message is returned.
If
.Fn re_comp
is passed 0 or a null string, it returns without changing the currently
compiled regular expression.
.Pp
The
.Fn re_exec
function
returns 1 if the string
.Fa s
matches the last compiled regular expression, 0 if the string
.Fa s
failed to match the last compiled regular expression, and \-1 if the compiled
regular expression was invalid (indicating an internal error).
.Pp
The strings passed to both
.Fn re_comp
and
.Fn re_exec
may have trailing or embedded newline characters;
they are terminated by
.Dv NUL Ns s .
The regular expressions recognized are described in the manual entry for
.Xr ed 1 ,
given the above difference.
.Sh DIAGNOSTICS
The
.Fn re_exec
function
returns \-1 for an internal error.
.Pp
The
.Fn re_comp
function
returns one of the following strings if an error occurs:
.Bd -unfilled -offset indent
No previous regular expression,
Regular expression too long,
unmatched \e(,
missing ],
too many \e(\e) pairs,
unmatched \e).
.Ed
.Sh SEE ALSO
.Xr ed 1 ,
.Xr egrep 1 ,
.Xr ex 1 ,
.Xr fgrep 1 ,
.Xr grep 1 ,
.Xr regex 3
.Sh HISTORY
The
.Fn re_comp
and
.Fn re_exec
functions appeared in
.Bx 4.0 .
